#include "Random.es30.glsl"

VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = createVertexOut();

  vec4 inPosition = positionTypeAsFloat4(In.Position);

  vec4 position = inPosition;

#if defined(BASE_MATERIAL_VERTEX_NORMAL0)
#if BASE_MATERIAL_VERTEX_NORMAL0 == COGS_FLOAT2
  vec3 normal = octDecode(In.Normal);
#else
  vec3 normal = In.Normal;
#endif
  Out.Normal = mat3(worldMatrix) * normal;
#endif

  Out.WorldPosition = worldMatrix * position;
  Out.Position = worldToClipMatrix * Out.WorldPosition;

#if BASE_MATERIAL_VERTEX_TEXCOORD0 == COGS_UINT
  uint id = wangHash(In.TexCoord);
#else
  uint id = wangHash(uint(In.TexCoord.x));
#endif

  Out.Color = vec3((1.0 / 255.0) * float((id >> 0u) & 255u),
                   (1.0 / 255.0) * float((id >> 8u) & 255u),
                   (1.0 / 255.0) * float((id >> 16u) & 255u));
  return Out;
}
