#include "Engine/Common.hlsl"
#include "Random.hlsl"

VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

  float4 inPosition = positionTypeAsFloat4(In.Position);

  float4 position = inPosition;

#if defined(BASE_MATERIAL_VERTEX_NORMAL0)
#if BASE_MATERIAL_VERTEX_NORMAL0 == COGS_FLOAT2
  float3 normal = octDecode(In.Normal);
#else
  float3 normal = In.Normal;
#endif
  Out.Normal = mul(normal, (float3x3)worldMatrix);
#endif

  Out.WorldPosition = mul(position, worldMatrix);
  Out.Position = mul(Out.WorldPosition, worldToClipMatrix);


  uint id = wangHash(uint(In.TexCoord.x));
  Out.Color = float3((1.0 / 255.0) * float((id >> 0u) & 255u),
                     (1.0 / 255.0) * float((id >> 8u) & 255u),
                     (1.0 / 255.0) * float((id >> 16u) & 255u));
  return Out;
}
