#version 300 es
precision highp float;
precision highp int;

uniform highp sampler2D opaqueColor;
uniform highp sampler2D accumA;
uniform highp sampler2D accumB;

uniform int outputSRGB;

out vec4 fragColor;

void main()
{
  vec4 accum = texelFetch(accumA, ivec2(gl_FragCoord.xy), 0);
  float r = accum.a;
  accum.a  = texelFetch(accumB, ivec2(gl_FragCoord.xy), 0).r;
  vec4 src = vec4(accum.rgb / clamp(accum.a, 1e-4, 5e5), r);

  // "blendMode": "InverseSourceAlpha_SourceAlpha"
  vec4 dst = texelFetch(opaqueColor, ivec2(gl_FragCoord.xy), 0);

  vec4 color = vec4(mix(src.rgb, dst.rgb, src.a), src.a + dst.a);

  if(outputSRGB != 0) {
    color.rgb = clamp(color.rgb, vec3(0.0), vec3(1.0));
    color.rgb = mix(pow(color.rgb, vec3(1.0/2.4)),
                    12.92 * color.rgb,
                    lessThan(color.rgb, vec3(0.0031308)));
  }
  fragColor = color;
}
