var Bridge = function (bridge) {
    var context = bridge.context;

    bridge.SetupContext = function () {
        bridge.setupContext(context);
    };

    bridge.ClearContext = function () {
        bridge.clearContext(context);
    }

    bridge.LoadScene = function (path, flags) {
        bridge.loadScene(context, path, flags);
    }

    bridge.LoadAsset = function (path, entityId, flags) {
        return bridge.loadAsset(context, path, entityId, flags);
    }

    bridge.LoadAssetFromString = function (contents, entityId, flags) {
        return bridge.loadAssetFromString(context, contents, entityId, flags);
    }

    bridge.Resize = function (x, y) {
        bridge.resize(context, x, y);
    }

    bridge.SetRenderMode = function (mode) {
        bridge.setRenderMode(context, mode);
    }

    bridge.SetVariable = function (key, value) {
        bridge.setVariable(context, key, value);
    }

    bridge.GetVariable = function (key) {
        return bridge.getVariable(context, key);
    }

    bridge.GetInputAction = function (key) {
        return bridge.getInputAction(context, key);
    };

    bridge.GetInputAxis = function (key) {
        return bridge.getInputAxis(context, key);
    };

    bridge.CreateEntity = function (type) {
        return bridge.createEntity(context, type);
    };

    bridge.DestroyEntity = function (id) {
        return bridge.destroyEntity(context, id);
    };

    bridge.GetEntity = function (name) {
        return bridge.getEntityId(context, name);
    };

    bridge.SetOrigin = function (value) {
        bridge.setOrigin(context, value);
    }

    bridge.GetPickedEntity = function (x, y, coordinates) {

    }

    bridge.GetProjectedCoordinates = function (canvas, x, y, normal, position) {

    }

    bridge.CalculateSceneBoundingBox = function () {

    }

    bridge.GetComponents = function (entity) {
        var comps = [];
        bridge.getComponents(context, entity.id, comps);
        return comps;
    }

    bridge.SetEntityName = function (entity, name) {
        bridge.setEntityName(context, entity.id, name);
    };

    bridge.RegisterDynamicType = function (name, mask) {
        bridge.registerDynamicType(context, name, mask);
    }

    bridge.RegisterMessageCallback = function (entity, typeId, func) {
        bridge.registerMessageCallback(context, entity.id, typeId, func);
    }

    bridge.GetMessageId = function (name) {
        return bridge.getMessageId(context, name);
    }

    bridge.AddComponent = function (entity, typeId) {
        bridge.addComponent(context, entity.id, typeId);
    }

    bridge.RemoveComponent = function (entity, typeId) {
        bridge.removeComponent(context, entity.id, typeId);
    }

    bridge.SetEntityField = function (entity, component, field, targetEntity) {
        bridge.setEntityField(context, entity.id, component, field, targetEntity !== null ? targetEntity.id : -1);
    };

    bridge.SetMultiEntityField = function (entity, component, field, targetEntities) {
        var ids = new Int32Array(targetEntities.length);
        for (var i = 0; i < targetEntities.length; ++i) {
            ids[i] = targetEntities[i].id;
        }
        bridge.setMultiEntityField(context, entity.id, component, field, new Uint8Array(ids.buffer, 0, Int32Array.BYTES_PER_ELEMENT * ids.length), ids.length);
    }

    bridge.SetFloatField = function (entity, component, field, value) {
        bridge.setFloatField(context, entity.id, component, field, value);
    };

    bridge.SetDoubleField = function (entity, component, field, value) {
        bridge.setDoubleField(context, entity.id, component, field, value);
    };

    bridge.SetIntegerField = function (entity, component, field, value) {
        bridge.setIntegerField(context, entity.id, component, field, value);
    };

    bridge.SetBoolField = function (entity, component, field, value) {
        bridge.setBoolField(context, entity.id, component, field, value);
    };

    bridge.SetVector2Field = function (entity, component, field, value) {
        throw "lol";
        //bridge.setVector2Field(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * 2));
    };

    bridge.SetVector2dField = function (entity, component, field, value) {
        var store = new Float64Array(value);
        bridge.setVector2dField(context, entity.id, component, field, new Uint8Array(store.buffer, 0, Float64Array.BYTES_PER_ELEMENT * 2));
    };

    bridge.SetVector3Field = function (entity, component, field, value) {
        bridge.setVector3Field(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * 3));
    };

    bridge.SetVector3dField = function (entity, component, field, value) {
        var store = (value instanceof Float64Array) ? value : new Float64Array(value);
        bridge.setVector3dField(context, entity.id, component, field, new Uint8Array(store.buffer, 0, Float64Array.BYTES_PER_ELEMENT * 3));
    };

    bridge.SetVector4Field = function (entity, component, field, value) {
        bridge.setVector4Field(context, entity.id, component, field, value);
    };

    bridge.SetQuaternionField = function (entity, component, field, value) {
        bridge.setQuaternionField(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * 4));
    };

    bridge.SetQuaterniondField = function (entity, component, field, value) {
        bridge.setQuaterniondField(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * 4));
    };

    bridge.SetMatrixField = function (entity, component, field, value) {
        bridge.setMatrixField(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * 16));
    };

    bridge.SetMultiFloatField = function (entity, component, field, value) {
        bridge.setMultiFloatField(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * value.length), value.length);
    };

    bridge.SetMultiIntegerField = function (entity, component, field, value) {
        bridge.setMultiIntegerField(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Int32Array.BYTES_PER_ELEMENT * value.length), value.length);
    };

    bridge.SetMultiVector2Field = function (entity, component, field, value) {
        bridge.setMultiVector2Field(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * value.length), value.length / 2);
    };

    bridge.SetMultiVector3Field = function (entity, component, field, value) {
        bridge.setMultiVector3Field(context, entity.id, component, field, value, value.length / 3);
    };

    bridge.SetMultiVector4Field = function (entity, component, field, value) {
        bridge.setMultiVector4Field(context, entity.id, component, field, new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * value.length), value.length / 4);
    };

    bridge.SetStringField = function (entity, component, field, value) {
        bridge.setStringField(context, entity.id, component, field, value);
    }

    bridge.SetMultiStringField = function (entity, component, field, value) {
        bridge.setMultiStringField(context, entity.id, component, field, value, value.length);
    }

    // Getters

    bridge.GetFieldValue = function (entity, component, field, value, type, count) {
        var array = new Uint8Array(type.BYTES_PER_ELEMENT * count)
        bridge.getFieldValue(context, entity.id, component, field, array);
        var result = new type(array.buffer, array.byteOffset, count);
        return count == 1 ? result[0] : result;
    };

    bridge.GetChildren = function (entity, component, field) {

    };

    bridge.GetBoolFieldValue = function (entity, component, field, value) {
        return bridge.GetFieldValue(entity, component, field, value, Uint8Array, 1) == 1;
    };

    // Mesh

    bridge.LoadMesh = function () {
        return bridge.loadMesh(context);
    };

    bridge.ReleaseMesh = function (mesh) {
        bridge.releaseMesh(context, mesh.id);
    };

    bridge.SetMeshData = function (mesh, stream, data, count) {
        bridge.setMeshData(context, mesh.id, stream, new Uint8Array(data.buffer, 0, data.BYTES_PER_ELEMENT * data.length), count);
    };

    bridge.SetMeshPrimitiveType = function (mesh, type) {
        bridge.setMeshPrimitiveType(context, mesh.id, type);
    };

    bridge.SetMeshField = function (entity, component, field, mesh) {
        bridge.setMeshField(context, entity.id, component, field, mesh ? mesh.id : Constants.NoResourceId);
    }

    bridge.SetMeshBoundingBox = function (mesh, boundingBox) {
        bridge.setMeshBoundingBox(context, mesh.id, new Uint8Array(boundingBox.data.buffer, 0, boundingBox.data.BYTES_PER_ELEMENT * boundingBox.data.length));
    };

    bridge.GetNextTextureId = function () {
        return bridge.getNextTextureId(context);
    }

    bridge.LoadTexture = function (id, data, width, height, bpp, stride, flags) {
        bridge.loadTextureResource(context, id, data, width, height, bpp, stride, flags);
    };

    bridge.LoadTextureResource = function (id, path, flags) {
        bridge.loadTexture(context, id, path, flags);
    };

    bridge.LoadExternalTexture = function (id, data, width, height, bpp, stride) {
        bridge.loadExternalTextureResource(context, id, data, width, height, bpp, stride, 0);
    };

    bridge.ReleaseTexture = function (texture) {
        bridge.releaseTexture(context, texture.id);
    };

    bridge.SetTextureField = function (entity, component, field, texture) {
        bridge.setTextureField(context, entity.id, component, field, texture ? texture.id : Constants.NoResourceId);
    };

    bridge.GetNextModelId = function () {
        return bridge.getNextModelId(context);
    }

    bridge.LoadModel = function (model) {
        return bridge.loadModel(context, model.path, model.id, 0);
    };

    bridge.ReleaseModel = function (model) {
        bridge.releaseModel(context, model.id);
    };

    bridge.SetModelField = function (entity, component, field, model) {
        bridge.setModelField(context, entity.id, component, field, model ? model.id : Constants.NoResourceId);
    };

    bridge.SetFontField = function (entity, component, field, font) {
        // Noop
    };

    bridge.LoadMaterial = function (name) {
        return bridge.loadMaterial(context, name);
    };

    bridge.LoadMaterialInstance = function (material) {
        return bridge.loadMaterialInstance(context, material.id);
    };

    bridge.ReleaseMaterialInstance = function (materialInstance) {
        bridge.releaseMaterialInstance(context, materialInstance.id);
    };

    bridge.SetMaterialInstanceField = function (entity, component, field, materialInstance) {
        bridge.setMaterialInstanceField(context, entity.id, component, field, materialInstance ? materialInstance.id : Constants.NoResourceId);
    };

    bridge.SetMaterialInstances = function (entity, component, field, instances) {
        for (var i = 0; i < instances.length; ++i) {
            bridge.setMaterialInstanceArrayField(context, entity.id, component, field, instances[i] ? instances[i].id : Constants.NoResourceId);
        }
    };

    bridge.SetBufferResourceField = function (entity, component, field, value) {
        // Noop
    };

    bridge.SetGuiDocumentField = function (entity, component, field, value) {
        // Noop
    };

    bridge.SetChildren = function (entity, component, field, values) {
        // Noop
    };

    var kMaxInstances = 16;

    bridge.GetMaterialInstances = function (entity, component, field, instances) {
        var resourceIds = bridge.getMaterialInstances(context, entity.id, component, field);

        if (instances) {
            for (var i = 0; i < kMaxInstances; ++i) {
                // Iff differing id, create wrapper
            }
        } else {
            instances = new Array(kMaxInstances);
            for (var i = 0; i < kMaxInstances; ++i) {
                if (resourceIds[i] != Constants.NoResourceId) {
                    instances[i] = MaterialInstance.createWrapper(bridge, resourceIds[i]);
                }
            }
        }

        return instances;
    };

    bridge.GetMaterialInstance = function (entity, component, field) {
        var id = bridge.getMaterialInstance(context, entity.id, component, field);

        return MaterialInstance.createWrapper(bridge, id);
    }

    var isNumeric = function (n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    };

    bridge.SetMaterialInstanceProperty = function (materialInstance, key, value, force) {
        if (value.constructor.name == "Float32Array" || force) {
            var data = new Uint8Array(value.buffer, 0, Float32Array.BYTES_PER_ELEMENT * value.length);
            bridge.setMaterialInstanceProperty(context, materialInstance.id, key, data, Float32Array.BYTES_PER_ELEMENT * value.length);
        } else if (isNumeric(value)) {
            var f = new Float32Array(1);
            f[0] = value;
            bridge.SetMaterialInstanceProperty(materialInstance, key, f, true);
        } else {
            // Unsupported, throw error
            throw "Unsupported property type.";
        }
    };

    bridge.SetMaterialInstanceTexture = function (materialInstance, key, texture) {
        bridge.setMaterialInstanceTexture(context, materialInstance.id, key, texture ? texture.id : Constants.NoResourceId);
    }

    bridge.SetMaterialInstanceTextureAddressMode = function (materialInstance, key, mode) {
        bridge.setMaterialInstanceTextureAddressMode(context, materialInstance.id, key, mode);
    }

    bridge.RegisterStringResource = function (key, value) {
        bridge.registerStringResource(context, key, value);
    }

    return bridge;
};

try {
    bridge = Bridge(bridge || {});
} catch (e) {
    console.log(e.stack);
}
