VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

  //compute position without translation
  float3 position_w = mul(In.Position.xyz, (float3x3)worldMatrix).xyz;
  float3 position = mul(position_w, (float3x3)viewMatrix).xyz;

  float f = 2.f; //far plane dist
  float n = 0.1f; //near plane dist

  float A = -(f + n) / (f - n);
  float B = -(2.0 * f * n) / (f - n);

  float4x4 modifiedProjection = projectionMatrix;

  if (abs(projectionMatrix[2][3]) < 0.000001) { //orthographic camera check
    float a = projectionMatrix[0][0]/projectionMatrix[1][1]; // find view aspect ratio
    float e = (2.0 * 30.0) / 24.0;

    modifiedProjection = float4x4(e*a, 0.f, 0.f, 0.f,
                              0.f, e, 0.f, 0.f,
                              0.f, 0.f, A, -1.f,
                              0.f, 0.f, B, 0.f);
  } else {
    modifiedProjection[0][2] = 0;
    modifiedProjection[1][2] = 0;
    modifiedProjection[2][2] = A;
    modifiedProjection[3][2] = B;
  }

  Out.Position = mul(float4(position, 1), modifiedProjection);
  Out.Direction = float4(In.Position.xyz, 0);
  Out.TexCoord = In.TexCoord;

  return Out;
}
