#ifndef COGS_CORE_BAYER_ES20_GLSL
#define COGS_CORE_BAYER_ES20_GLSL

float bayer4(vec2 p)
{
  vec2 t = floor(mod(p, 4.0));

  int y1 = 2.0 <= t.y ? 1 : 0;
  if (y1 != 0) t.y -= 2.0;
  int y0 = 1.0 <= t.y ? 1 : 0;

  int x1 = 2.0 <= t.x ? 1 : 0;
  if (x1 != 0) t.x -= 2.0;
  int x0 = 1.0 <= t.x ? 1 : 0;

  return (1.0 / 16.0) * float(y1 + 2 * (y1 + x1 - 2 * y1*x1) + 4 * y0 + 8 * (y0 + x0 - 2 * y0 * x0));
}

#endif
