cbuffer ImguiBuffer : register(b0)
{
  float4x4 ProjectionMatrix;
  int ShowAlpha;
  int TexMode;
  int Offset;
};

struct PS_INPUT
{
  float4 pos : SV_Position;
  float4 col : COLOR0;
  float2 uv  : TEXCOORD0;
};

Texture2D texture0;
SamplerState texture0Sampler;

#ifdef COGS_OPENGL_ES
Texture2DArray texarray;
#endif

TextureCube texcube;

float4 main(PS_INPUT input) : SV_Target
{
  float4 texColor;
  if (TexMode == 0) {
    texColor = texture0.Sample(texture0Sampler, input.uv);
  }
  else if (TexMode == 1) {
#ifdef COGS_OPENGL_ES
    texColor = texarray.Sample(texture0Sampler, float3(input.uv, Offset));
#else
    texColor = float4(1, 0, 1, 1);
#endif
  }
  else if (TexMode == 2) {
    texColor = float4(0, 1, 0, 1);
  }

  if (ShowAlpha == 1)
  {
    texColor = float4(texColor.aaa, 1);
  }
  else if (ShowAlpha == 2) {
    texColor = float4(texColor.rrr, 1);
  }
  float4 color = input.col * texColor;
  return color;
}
