cbuffer UpscaleParameters
{
  uint2 scale;
};

struct VertexIn
{
  float4 Position : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
  float2 TexCoords : TEXCOORD1;
};

struct PixelOut
{
  float4 Color : SV_Target;
  float Depth : SV_Depth;
};

Texture2D oitTexture;
Texture2D colorTexture;
Texture2D depthTexture;
SamplerState linearSampler;

PixelOut main(VertexIn In, float4 ScreenPos : SV_Position)
{
  const float3 background = colorTexture.Load(int3(ScreenPos.xy, 0)).rgb;
  const float backgroundDepth = depthTexture.Load(int3(ScreenPos.xy, 0)).r;

  /* uint2 tex = ScreenPos.xy/scale; */
  /* const float4 oit = oitTexture.Load(int3(tex, 0)).rgba; */

  float2 texC = In.ScreenPosition.xy*float2(0.5, -0.5)+float2(0.5, 0.5);
  const float4 oit = oitTexture.SampleLevel(linearSampler, texC, 0).rgba;

  PixelOut Out;
  Out.Color.rgb = oit.rgb + oit.a*background.rgb;
  Out.Color.a = 1.0;
  Out.Depth = backgroundDepth;

  return Out;
}
