VertexOut vertexFunctionGS(VertexIn input)
{
  VertexOut output = (VertexOut)0;

  output.Position = mul(mul(float4(input.Position.xyz, 1.0), worldMatrix), worldToClipMatrix);

  return output;
}

#ifndef VERTEX_FUNCTION
VertexOut vertexFunction(VertexIn input)
{
  VertexOut output = (VertexOut)0;

  float4 cp = mul(mul(float4(input.Position.xyz, 1.0), worldMatrix), worldToClipMatrix);
  float scale = 1.0 / cp.w;
  float3 p = scale * cp.xyz;

  float2 corner = float2(input.Position.w < 0.0 ? 1 : 0, abs(input.Position.w) < 2.f ? 1 : 0) - float2(0.5, 0.5);
  output.texCoord = pointSizes.x * corner;

  float scaledPointSize = clamp(scale * pointSizes.x, pointSizeClamp.x, pointSizeClamp.y);
  p.xy = floor(viewportScale.xy * p.xy) + float2(0.5, 0.5) + scaledPointSize * corner;

  output.Position = float4(viewportScale.zw * p.xy, p.z, 1.0);

  return output;
}
#endif