cbuffer MipLevelsParameter
{
  float2 srcTexelSize;
  float2 dstTexelSize;
  int srcLevel;
  int dstLevel;
};

Texture2D colorTexture;
SamplerState colorTextureSampler;

struct VertexIn
{
  float4 ScreenPos : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
  float2 UnitPosition : TEXCOORD1;
};

float4 main(VertexIn In) : SV_Target
{
  return float4((1.0/4.0)*(colorTexture.Sample(colorTextureSampler, In.UnitPosition + float2( srcTexelSize.x,  srcTexelSize.y), 0).rgb +
                           colorTexture.Sample(colorTextureSampler, In.UnitPosition + float2(-srcTexelSize.x,  srcTexelSize.y), 0).rgb +
                           colorTexture.Sample(colorTextureSampler, In.UnitPosition + float2( srcTexelSize.x, -srcTexelSize.y), 0).rgb +
                           colorTexture.Sample(colorTextureSampler, In.UnitPosition + float2(-srcTexelSize.x, -srcTexelSize.y), 0).rgb),
                 1.0);
}
