float lightScale;
float rampStart;
float rampScale;
float rampWidth;

Texture2D colorTexture;
SamplerState colorTextureSampler;

RWStructuredBuffer<float>  exposureBuffer;

struct VertexIn
{
  float4 ScreenPos : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
  float2 UnitPosition : TEXCOORD1;
};

float4 main(VertexIn In) : SV_Target
{
  const float3 A = colorTexture.Load(int3(2 * In.ScreenPos.xy + int2(0, 0), 0)).rgb;
  const float3 B = colorTexture.Load(int3(2 * In.ScreenPos.xy + int2(1, 0), 0)).rgb;
  const float3 C = colorTexture.Load(int3(2 * In.ScreenPos.xy + int2(0, 1), 0)).rgb;
  const float3 D = colorTexture.Load(int3(2 * In.ScreenPos.xy + int2(1, 1), 0)).rgb;
  float3 color = 0.25*(A + B + C + D);

  float exposure = exposureBuffer[0] * lightScale;
  float brightness = exposure*max(max(color.r, color.g), color.b);

  float t = saturate(rampScale*(brightness - rampStart));

  return float4(t*t*color, 1.0);
}
