#version 300 es
precision highp float;
precision highp int;

uniform vec4 color;
uniform float brightness;
uniform sampler2D colorTexture;

in vec2 NormalizedCoords;

out vec4 fragColor;

void main()
{
  vec4 colorIn = texture(colorTexture, NormalizedCoords);

  float lightness = clamp(colorIn.r * 0.2126 + colorIn.g * 0.7152 + colorIn.b * 0.0722, 0.0, 1.0);

  fragColor = vec4(brightness * color.rgb * lightness, 1);
}
