#version 100
#extension GL_EXT_shader_texture_lod : enable
#if 0
#endif

precision highp float;
precision highp int;
varying vec2 NormalizedCoords;
uniform sampler2D inTex;
uniform vec2 viewportSize;
uniform float qualitySubpix;
uniform float qualityEdgeThreshold;
uniform float qualityEdgeThresholdMin;
uniform float debugView;

#define FXAA_PC 1
#define FXAA_GLSL_120 1
#define FXAA_GATHER4_ALPHA 0
#define FXAA_FAST_PIXEL_OFFSET 0
#define texture2DLod texture2DLodEXT

#include "PostProcess/Fxaa3_11.hlsl"


void main()
{
    vec2 qualityRcpFrame = vec2(1,1)/viewportSize;  // 1.0/screenWidthInPixels
    vec4 t = FxaaPixelShader(NormalizedCoords.xy,   // FxaaFloat2 pos
                            vec4(0, 0, 0, 0),       // FxaaFloat4 fxaaConsolePosPos
                            inTex, inTex, inTex,    // FxaaTex tex, fxaaConsole360TexExpBiasNegOne, fxaaConsole360TexExpBiasNegTwo
                            qualityRcpFrame,        // FxaaFloat2 fxaaQualityRcpFrame    
                            vec4(0, 0, 0, 0),       // FxaaFloat4 fxaaConsoleRcpFrameOpt
                            vec4(0, 0, 0, 0),       // FxaaFloat4 fxaaConsoleRcpFrameOpt2,
                            vec4(0, 0, 0, 0),       // FxaaFloat4 fxaaConsole360RcpFrameOpt2,
                            qualitySubpix,          // FxaaFloat fxaaQualitySubpix,
                            qualityEdgeThreshold,   // FxaaFloat fxaaQualityEdgeThreshold
                            qualityEdgeThresholdMin,// FxaaFloat fxaaQualityEdgeThresholdMin
                            0.0,                    // FxaaFloat fxaaConsoleEdgeSharpness,
                            0.0,                    // FxaaFloat fxaaConsoleEdgeThreshold,
                            0.0,                    // FxaaFloat fxaaConsoleEdgeThresholdMin,
                            vec4(0, 0, 0, 0));      // FxaaFloat4 fxaaConsole360ConstDir

    if(debugView != 0.0) {
        if(NormalizedCoords.x < 0.5) {
            t = texture2D(inTex, NormalizedCoords);
        }
        else if(NormalizedCoords.x < 0.5 + 2.0/viewportSize.x) {
            t = vec4(1, 0, 0, 0);
        }
    }
    gl_FragColor = vec4(t.rgb, 1.0);
}
