#include "AtmosphericScattering.hlsl"

SurfaceOut surfaceFunction(VertexIn In)
{
  SurfaceOut Out = (SurfaceOut)0;

  Out.Color = float4(1,0,1,1);
  Out.Normal = float3(1, 1, 1);

  clip(In.vLocalPosition.z);

  // Compute cos angle between light direction and vertex position
  float3 vVertexPositionNormalized = normalize(In.vLocalPosition);
  float fCos = dot(-GetSunDirection().xzy, vVertexPositionNormalized);
  float fSkydomeSunnySide = (fCos < 0.0 ? 1.0 : 0.0);

  float3 vAtmosphericScatteringColor = ComputeAtmosphericScatteringColor(In.vRayleighColor, In.vMieColor, fCos, fSkydomeSunnySide);

  Out.Color = float4(vAtmosphericScatteringColor, 1.0f);

  return Out;
}
